local ConRO_Priest, ids = ...;

local defaults = {
	["ConRO_DisciplinePriest_AtonementThreshold"] = 8,
}

ConROPriestSpells = ConROPriestSpells or defaults;

function ConRO_ShowAtonement()
	ConROButtonFrame:Show();
	ConRO_BurstButton:Hide();
	ConRO_FullButton:Hide();
	ConRO_AutoButton:Hide();
	ConRO_SingleButton:Hide();
	ConRO_AoEButton:Hide();
	ConRO_AtonementButton:Show();
	ConRO_RaidAtonementButton:Show();
end

function ConRO:CreateAtonementButton()
	local tbutton = CreateFrame("Button", 'ConRO_AtonementButton', ConROButtonFrame)
		tbutton:SetFrameStrata('MEDIUM');
		tbutton:SetFrameLevel('6')
		tbutton:SetPoint("TOPLEFT", "ConROButtonFrame", "TOPLEFT", 7, -7)
		tbutton:SetSize(40, 15)
		tbutton:Hide()
		tbutton:SetAlpha(1)
		
		tbutton:SetText("At: " .. ConRO:GroupBuffCount(ids.Disc_Buff.Atonement))
		tbutton:SetNormalFontObject("GameFontHighlightSmall")
		
		tbutton:SetScript("OnEnter", AtoneOnEnter)
		tbutton:SetScript("OnLeave", AtoneOnLeave)

	local ntex = tbutton:CreateTexture()
		ntex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonUp")
		ntex:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex:SetVertexColor(0, 0, 0, 1)
		ntex:SetAllPoints()	
		tbutton:SetNormalTexture(ntex)
		
		tbutton:SetScript("OnMouseDown", function (self, tbutton, up)
			if ConRO.db.profile.unlockWindow then
				ConROButtonFrame:StartMoving();
				self.isMoving = true;
			end
		end)
		
		tbutton:SetScript("OnMouseUp", function (self, tbutton, up)
			if ConRO.db.profile.unlockWindow then
				ConROButtonFrame:StopMovingOrSizing();
				self.isMoving = false;
			end
		end)
end

function ConRO:CreateRaidAtonementButton()
	local tbutton = CreateFrame("Button", 'ConRO_RaidAtonementButton', ConROButtonFrame)
		tbutton:SetFrameStrata('MEDIUM');
		tbutton:SetFrameLevel('6')
		tbutton:SetPoint("BOTTOMRIGHT", "ConROButtonFrame", "BOTTOMRIGHT", -7, 7)
		tbutton:SetSize(40, 15)
		tbutton:Hide()
		tbutton:SetAlpha(1)
		
		tbutton:SetText("Raid:    ")
		tbutton:SetNormalFontObject("GameFontHighlightSmall")
		
		tbutton:SetScript("OnEnter", AtoneOnEnter)
		tbutton:SetScript("OnLeave", AtoneOnLeave)
	
	local box1 = CreateFrame("EditBox", 'ConRO_AtonementBox', tbutton);	
		box1:SetPoint("BOTTOMRIGHT", "ConROButtonFrame", "BOTTOMRIGHT", -1, 7);
		box1:SetMultiLine(false);
		box1:SetFontObject(GameFontNormalSmall);
		box1:SetNumeric(true);
		box1:SetAutoFocus(false);
		box1:SetMaxLetters("2");
		box1:SetWidth(20);
		box1:SetHeight(15);
		box1:SetTextInsets(3, 0, 0, 0);
		box1:SetNumber(ConROPriestSpells.ConRO_DisciplinePriest_AtonementThreshold);

		box1:SetScript("OnEditFocusLost", 
			function()
				ConROPriestSpells.ConRO_DisciplinePriest_AtonementThreshold = ConRO_AtonementBox:GetNumber();
				box1:ClearFocus()
			end);
		box1:SetScript("OnEnterPressed", 
			function()
				ConROPriestSpells.ConRO_DisciplinePriest_AtonementThreshold = ConRO_AtonementBox:GetNumber();
				box1:ClearFocus()
			end);
		box1:SetScript("OnEscapePressed", 
			function()
				ConROPriestSpells.ConRO_DisciplinePriest_AtonementThreshold = ConRO_AtonementBox:GetNumber();
				box1:ClearFocus()
			end);
			
	local ntex = tbutton:CreateTexture()
		ntex:SetTexture("Interface\\AddOns\\ConRO\\images\\buttonUp")
		ntex:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex:SetVertexColor(0, 0, 0, 1)
		ntex:SetAllPoints()	
		tbutton:SetNormalTexture(ntex)
		
		tbutton:SetScript("OnMouseDown", function (self, tbutton, up)
			if ConRO.db.profile.unlockWindow then
				ConROButtonFrame:StartMoving();
				self.isMoving = true;
			end
		end)
		
		tbutton:SetScript("OnMouseUp", function (self, tbutton, up)
			if ConRO.db.profile.unlockWindow then
				ConROButtonFrame:StopMovingOrSizing();
				self.isMoving = false;
			end
		end)
end

function ConRO:Atonements(_Atonement_COUNT)

	return ConRO_AtonementButton:SetText("At: " .. _Atonement_COUNT);
end

ConRO:CreateAtonementButton();
ConRO:CreateRaidAtonementButton();